package com.hyperling.examplegame_practice;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Rect;

/**
 * Created by usb on 12/19/14.
 */
public class Bullet {

    int speed = 100;
    int pauseSpeed = 1;
    int xSpeed, ySpeed;
    int damage;

    Bitmap bmp;

    int width, height;

    int centerX, centerY;

    int startX, startY;
    int x, y;

    Minion minion;

    boolean xLocked, yLocked;
    boolean spent = false;

    public Bullet(GameView gv, Bitmap bmp, int damage, int startX, int startY, Minion minion){
        width = bmp.getWidth();
        height = bmp.getHeight();

        centerX = startX;
        centerY = startY;

        this.startX = centerX - width/2;
        this.startY = centerY - height/2;

        x = this.startX;
        y = this.startY;

        this.minion = minion;

        this.bmp = bmp;

        this.damage = damage;

        xSpeed = gv.getWidth()/speed;
        ySpeed = gv.getHeight()/speed;
        xLocked = false;
        yLocked = false;
    }

    public void update(){

        // Minion location towards minion
        int x2 = minion.centerX;
        int y2 = minion.centerY;

        // Which direction do we need to move?
        // Find the sign on the direction, then multiply by the speed
        if(xLocked){
            x = minion.centerX - width/2;
        }
        else {
            try {
                x = x + (((x2 - centerX) / Math.abs(x2 - centerX)) * xSpeed * pauseSpeed);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        if(yLocked) {
            y = minion.centerY - height / 2;
        }
        else {
            try {
                y = y + (((y2 - centerY) / Math.abs(y2 - centerY)) * ySpeed * pauseSpeed);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        centerX = x + width/2;
        centerY = y + height/2;
    }

    public void onDraw(Canvas canvas){
        update();

        Rect src = new Rect(startX, startY, startX + width, startY + height);

        Rect dest = new Rect(x, y, x + width, y + height);

        canvas.drawBitmap(bmp, src, dest, null);
    }

    public boolean isCollision(){
        boolean collide = false;

        if((x + width >= minion.x || x < minion.x + minion.width) && (y + height > y || y <= minion.y + minion.height)){
            collide = true;
        }

        return collide;
    }
}
