package com.hyperling.examplegame_practice;

import android.annotation.SuppressLint;
import android.graphics.Canvas;

/**
 * Created by usb on 10/23/14.
 */
public class GameLoopThread extends Thread{

    private GameView gameView;
    private boolean running = false;

    static final long FPS = 10;

    public GameLoopThread(GameView gv){
        gameView = gv;
    }

    public void setRunning(boolean run){
        running = run;
    }

    @SuppressLint("WrongCall")
    @Override
    public void run(){

        long tick = 1000 / FPS;
        long startTime;
        long sleepTime;

        while(running){
            Canvas c = null;
            startTime = System.currentTimeMillis();
            try {
                c = gameView.getHolder().lockCanvas();
                synchronized (gameView.getHolder()) {
                    gameView.onDraw(c);
                }
            } finally {
                if (c != null) {
                    gameView.getHolder().unlockCanvasAndPost(c);
                }
            }
            sleepTime = tick - (System.currentTimeMillis() - startTime);

            try {
                if (sleepTime > 0) {
                    sleep(sleepTime);
                }
                else {
                    sleep(10);
                }
            } catch (Exception e) {}
        }
    }
}
