package com.hyperling.examplegame_practice;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Rect;

/**
 * Created by usb on 10/23/14.
 */
public class Minion {

    // How many rows and columns? Must find the little guy
    private static final int BMP_ROWS = 4;
    private static final int BMP_COLUMNS = 3;

    // Direction the guy moves according to quadrants
    String directions[] = {"down", "left", "right", "up"};

    // Default speed
    private final int SPEED_PER_STEP;

    // Variables
    int x, y, xSpeed, ySpeed, currentFrame, width, height;

    int centerX, centerY;

    GameView gameView;

    Bitmap bmp;

    //int role; //determines speed and health
    int health;

    long slowedTime;
    boolean isSlowed;
    int slow = 1;

    public Minion(GameView gv, Bitmap bm, int role, int speed, int startX, int startY){
        gameView = gv;
        bmp = bm;
        health = role;
        this.SPEED_PER_STEP = speed;

        xSpeed = SPEED_PER_STEP;
        ySpeed = 0;

        //Find size of individual character, not entire bitmap
        width = bmp.getWidth() / BMP_COLUMNS;
        height = bmp.getHeight() / BMP_ROWS;

        x = startX;
        y = startY - (height/2);
    }

    private void update(){
        /*
        //Turn around if hitting x walls
        if(x > gameView.getWidth() - width - xSpeed){
            xSpeed = -xSpeed;
        }
        if(x + xSpeed < 0){
            xSpeed = Math.abs(xSpeed);
        }
        */
        int movement;

        if(isSlowed){
            slow = 3;
        }

        if(xSpeed > 0) {
            movement = (gameView.getWidth() / (xSpeed));
        } else {
            movement = 0;
        }
        x = x + movement/slow;
        centerX = x + width/2;


        /*
        //Turn around if hitting y walls
        if(y > gameView.getWidth() - height - ySpeed){
            ySpeed = -ySpeed;
        }
        if(y + ySpeed < 0){
            ySpeed = Math.abs(ySpeed);
        }
        */

        if(ySpeed > 0) {
            movement = (gameView.getHeight() / ySpeed);
        } else {
            movement = 0;
        }
        y = y + movement/slow;
        centerY = y + height/2;

        // Make him look like he's walking
        // %BMP_COLUMNS makes it stay withing bounds
        currentFrame = ++currentFrame % BMP_COLUMNS;

        if(isSlowed){
            if(System.currentTimeMillis() - slowedTime > 1000){
                isSlowed = false;
                slow = 1;
            }
        }
    }

    public void onDraw(Canvas canvas) {

        // Move the guy
        update();

        int srcX = currentFrame * width;
        int srcY = getAnimationRow() * height;

        Rect src = new Rect(srcX, srcY, srcX + width, srcY + height);

        Rect dest = new Rect(x, y, x + width, y + height);

        canvas.drawBitmap(bmp, src, dest, null);
    }

    private int getAnimationRow() {

        String dir = "";
        String xdir = "";
        String ydir = "";
        int i;

        // If stationary, look down
        if(xSpeed == 0 && ySpeed == 0){
            dir = "down";
        }
        else {
            // Find x direction
            if(xSpeed > 0) {
                xdir = "right";
            } else {
                xdir = "left";
            }

            // Find y direction
            if(ySpeed > 0){
                ydir = "down";
            }
            else{
                ydir = "up";
            }

            // Use whichever is stronger
            if(Math.abs(xSpeed) > Math.abs(ySpeed)){
                dir = xdir;
            }
            else{
                dir = ydir;
            }
        }

        // Match i for the direction
        for(i = 0; i < 4; i++){
            //System.out.println("dir is " + dir);
            //System.out.println("x + xSpeed are " + (x+xSpeed));
            //System.out.println("i says " + directions[i]);
            if(directions[i].equals(dir)){
                break;
            }
        }
        //System.out.println(i);
        return i;
    }

    public boolean isCollision(int x2, int y2) {

        return x2 > x && x2 < x + width && y2 > y && y2 < y + height;

    }

    public boolean isCollision(int[] side) {
        boolean isInside = false;

        if(x > side[0] && x < side[2] && y > side[1] && y < side[3]){
            isInside = true;
        }

        return isInside;
        //return x2 > x && x2 < x + width && y2 > y && y2 < y + height;

    }

    /*
    public int getRole() {

        return role;
    }
    */

    public int[] getCellLocation(int numRows, int numColumns){
        int i = gameView.getHeight()/numRows;
        int j = gameView.getWidth()/numColumns;

        int[] a = {i,j};
        return a;
    }

}
